<template>
	<div class="form-select" :style="wrapperStyle">
		<input type="hidden" :name="name" :id="id" :value="value">
		<span class="form-select__input" @click="toggle" :style="spanStyle">{{ selectedLabel }}</span>
		<svg class="form-select__trigger" :class="triggerClass" :style="triggerStyle" @click="toggle">
			<use xlink:href="/img/sprite.svg#right-arrow-circular-button"/>
		</svg>
		<transition name="slide" :duration="500">
			<div class="form-select__options" v-if="opened" :style="optionsStyle">
				<span class="form-select__option" v-for="(label, v) in optionsObject" @click="select(v)">{{ label }}</span>
			</div>
		</transition>
	</div>
</template>

<script>
export default {
	name: "FormSelect",
	props: {
		value: String|Number,
		name: String,
		id: String,
		options: {
			type: Object|Array,
			default: () => {},
		},
		wrapperStyle: {
			type: Object|String,
			default: () => {},
		},
		spanStyle: {
			type: Object|String,
			default: () => {},
		},
		customOptionsStyle: {
			type: Object,
			default: () => {},
		},
		triggerStyle: {
			type: Object|String,
			default: () => {},
		}
	},
	model: {
		prop: 'value',
		event: 'change'
	},
	data(){
		return {
			opened: false,
		}
	},
	computed: {
		optionsObject(){
			if(Array.isArray(this.options)){
				let result = {};
				this.options.forEach(value => {
					result[value] = value;
				});
				return result
			}
			return this.options;
		},
		triggerClass(){
			return {
				'form-select__trigger--opened': this.opened
			}
		},
		selectedLabel(){
			return this.optionsObject[this.value];
		},
		optionsStyle(){
			let em = 2 + Object.keys(this.optionsObject).length;
			let px = Object.keys(this.optionsObject).length * 14;
			return _.merge({
				'max-height': `calc(${em}em + ${px}px)`
			}, this.customOptionsStyle);
		}
	},
	methods: {
		select(value){
			this.$emit('change', value);
			this.close();
		},
		close(){
			this.opened = false;
		},
		open(){
			this.opened = true;
		},
		toggle(){
			this.opened = !this.opened;
		}

	}
}
</script>

<style scoped lang="scss">
.form-select{
	position: relative;

	&__input{
		color: #2b5ede;
		width: calc(100% - 15px);
		border-radius: 8px;
		background-color: #efefef;
		font-size: 14px;
		padding: 10px 0 10px 1em;
		display: inline-block;
		cursor: pointer;
	}
	&__trigger{
		width: 20px;
		height: 20px;
		fill: #cdcdcd;
		position: absolute;
		top: 0;
		bottom: 0;
		margin: auto;
		right: 13px;
		-webkit-transform: rotate(90deg);
		transform: rotate(90deg);
		cursor: pointer;
		transition-duration: 500ms;
		transition-property: -webkit-transform, transform;

		&--opened{
			-webkit-transform: rotate(270deg);
			transform: rotate(270deg);
		}
	}
	&__options{
		display: block;
		position: absolute;
		top: calc(100% + 10px);
		width: calc(100% - 2em);
		box-shadow: 0 20px 32px rgba(147, 147, 147, 0.18);
		background-color: #efefef;
		border-radius: 5px;
		padding: 1em;
		overflow: hidden;
	}
	&__option{
		display: inline-block;
		width: 100%;
		color: #a1a1a1;
		font-family: "Geometria",serif;
		font-size: 14px;
		font-weight: 400;
		line-height: 20px;
		transition-duration: 500ms;
		transition-property: color;
		cursor: pointer;
		margin: 0 0 1em;

		&:hover{
			color: #2b5ede;
		}
	}
}
.slide-enter-active,
.slide-leave-active {
	transition: max-height .5s ease;
}
.slide-enter,
.slide-leave-to {
	max-height: 0 !important;
}
</style>
